/**********************************************************************
 * ISO MPEG Audio Subgroup Software Simulation Group (1996)
 * ISO 13818-3 MPEG-2 Audio Encoder - Lower Sampling Frequency Extension
 *
 * $Id: loop-pvt.h,v 1.1 1996/02/14 04:04:23 rowlands Exp $
 *
 * Private interface declarations for loop.c
 *
 * $Log: loop-pvt.h,v $
 * Revision 1.1  1996/02/14 04:04:23  rowlands
 * Initial revision
 *
 * Received from Mike Coleman
 **********************************************************************/

#ifndef LOOP_PVT_H
#define LOOP_PVT_H

/*
  Revision History:

  Date        Programmer                Comment
  ==========  ========================= ===============================
  1995/10/01  mc@fivebats.com           created

*/

void outer_loop( double xr[2][2][576],     /*vector of the magnitudees of the spectral values */
                long bits,
		double noise[4],
                double targ_noise[4],    /* VBR target noise info */
                long sloppy,              /* 1=quit as soon as noise < targ_noise */
                III_psy_xmin  *l3_xmin, /* the allowed distortion of the scalefactor */
                long l3_enc[2][2][576],    /* vector of quantized values ix(0..575) */
		frame_params *fr_ps,
                III_scalefac_t *scalefac, /* scalefactors */
                long gr,
                long stereo,
		III_side_info_t *l3_side,
		III_psy_ratio *ratio, 
		double ms_ratio,
		long ch);


void outer_loop_dual( double xr[2][2][576],     /*vector of the magnitudees of the spectral values */
		 double xr_org[2][2][576],
                long mean_bits,
                long VBRbits[2][2],
                long bit_rate,
		long best_over[2],
                III_psy_xmin  *l3_xmin, /* the allowed distortion of the scalefactor */
                long l3_enc[2][2][576],    /* vector of quantized values ix(0..575) */
		frame_params *fr_ps,
                III_scalefac_t *scalefac, /* scalefactors */
                long gr,
                long ch,
		III_side_info_t *l3_side,
		III_psy_ratio *ratio, 
		double pe[2][2],
		double ms_ratio[2]);



long part2_length( III_scalefac_t *scalefac,
		  long version, gr_info *cod_info);

long quantanf_init( double xr[576] );

long inner_loop( double xr[2][2][576], double xrpow[576],
                long l3_enc[2][2][576],
                long max_bits,
                gr_info *cod_info,
                long gr,
                long ch );
void calc_xmin( double xr[2][2][576],
               III_psy_ratio *ratio,
               gr_info *cod_info,
               III_psy_xmin *l3_xmin,
               long gr,
               long ch );
double xr_max( double xr[576],
               unsigned long begin,
               unsigned long end );

void calc_scfsi( double  xr[576],
                 III_side_info_t *l3_side,
                 III_psy_xmin  *l3_xmin,
                 long ch,
                 long gr );

void gr_deco( gr_info *cod_info );


long count_bit( long ix[576], unsigned long start, unsigned long end, unsigned long table);
long bigv_bitcount( long ix[576], gr_info *cod_info );
long choose_table( long max);
void bigv_tab_select( long ix[576], gr_info *cod_info );
void subdivide( gr_info *cod_info );
long count1_bitcount( long ix[576], gr_info *cod_info );
void  calc_runlen( long ix[576],
                   gr_info *cod_info );
long scale_bitcount( III_scalefac_t *scalefac,
                    gr_info *cod_info,
                    long gr,
                    long ch );
long scale_bitcount_lsf( III_scalefac_t *scalefac, gr_info *cod_info,
                    long gr, long ch );
long calc_noise1( double xr[576],
                 long ix[576],
                 gr_info *cod_info,
                 double xfsf[4][CBLIMIT], 
		 double distort[4][CBLIMIT],
                 III_psy_xmin  *l3_xmin,
		 long gr, long ch, 
                 double *noise, double *tot_noise, double *max_noise);

void calc_noise2( double xr[2][576],
                 long ix[2][576],
                 gr_info *cod_info[2],
                 double xfsf[2][4][CBLIMIT], 
		 double distort[2][4][CBLIMIT],
                 III_psy_xmin  *l3_xmin,
		 long gr, long ch, long over[2], 
                 double noise[2], double tot_noise[2], double max_noise[2]);


long loop_break( III_scalefac_t *scalefac,
                gr_info *cod_info,
                long gr,
                long ch );
long preemphasis( double xr[576], double xrpow[576],
                  III_psy_xmin  *l3_xmin,
                  long gr,
                  long ch,
		  III_side_info_t *l3_side,
                  double distort[4][CBLIMIT] );
long amp_scalefac_bands( double xr[576], double xrpow[576],
                        III_psy_xmin  *l3_xmin,
			III_side_info_t *l3_side,
                        III_scalefac_t *scalefac,
                        long gr,
                        long ch,
			long iteration,
                        double distort[4][CBLIMIT]);
long quantize( double xr[576],
               long  ix[576],
               gr_info *cod_info );
void quantize_xrpow( double xr[576],
               long  ix[576],
               gr_info *cod_info );
long ix_max( long ix[576],
            unsigned long begin,
            unsigned long end );


long
new_choose_table( long ix[576],
		  unsigned long begin,
		  unsigned long end, long * s );

/* New SS 20-12-96 */
long bin_search_StepSize(long desired_rate, double start, long bot, long ix[576],
           double xrs[576], double xrspow[576], gr_info * cod_info);
long bin_search_StepSize2(long desired_rate, double start, long bot, long ix[576],
           double xrs[576], double xrspow[576], gr_info * cod_info);
long count_bits(long  *ix,gr_info *cod_info);


long quant_compare(
long best_over,double best_tot_noise,double best_over_noise,double best_max_over,
long over,double tot_noise, double over_noise,double max_noise);

long VBR_compare(
long best_over,double best_tot_noise,double best_over_noise,double best_max_over,
long over,double tot_noise, double over_noise,double max_noise);


#endif
